package com.dtok.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import lombok.Data;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;
import java.util.Date;

/**
 * @Description  
 * @Author  C.J
 * @Date 2024-03-09 
 */

@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table ( name ="devices" )
public class Devices  implements Serializable {

	private static final long serialVersionUID =  7336812044556799572L;

	/**
	 * 自增ID

	 */
	@Id
   	@Column(name = "uuid" )
	private String uuid;

	/**
	 * 关联用户
	 */
   	@Column(name = "account" )
	private Long account;

	/**
	 * 手机型号
	 */
   	@Column(name = "device_name" )
	private String deviceName;

	/**
	 * 手机的系统版本
	 */
   	@Column(name = "device_version" )
	private String deviceVersion;

	/**
	 * 手机品牌
	 */
   	@Column(name = "device_brand" )
	private String deviceBrand;

	/**
	 * 最后连接时间
	 */
   	@Column(name = "last_connection_time" )
	private Date lastConnectionTime;

	/**
	 * 抖音版本
	 */
   	@Column(name = "tiktok_version" )
	private String tiktokVersion;

	/**
	 * ONLINE 在线
OFFLINE 离线
	 */
   	@Column(name = "status" )
	private String status;

	/**
	 * Android ID
	 */
   	@Column(name = "android_id" )
	private String androidId;

	/**
	 * 最后登录IP

	 */
   	@Column(name = "last_connection_ip" )
	private String lastConnectionIp;

}
